package com.icontrols.kakao.common;

import java.util.HashMap;
import java.util.Map;

public final class ERROR_INFO {

	public enum CODE {
		SUCCESS(200, "정상동작", "Success"),

		FAIL_602(602, "토큰 만료", "Token Expired"), FAIL_606(606, "요청을 수락할 수 없음", "Not Acceptable"),
		FAIL_661(661, "허용된 HTTP Method가 아님", "Method Not Allowed"),
		FAIL_662(662, "요청 Content-Type 미지원 오류", "Content-Type Not Allowed"),
		FAIL_670(670, "유효하지 않은 JSON 문자열", "Invalid JSON Body"),
		FAIL_671(671, "필수 Body 컨텐츠 누락", "Mandatory Field of Body Content Omitted"),
		FAIL_672(672, "Body 컨텐츠의 필드 길이, 데이터 타입등 필드 규칙 오류", "Invalid Body Content Field"),
		FAIL_693(693, "Service Unavailable", "Service Unavailable"),

		FAIL_801(801, "세션키 불일치", "Invalid Session Key"), 
		FAIL_802(802, "임시 인증키 불일치", "Invalid Temp Key Information"),
		FAIL_804(804, "등록된 디바이스 없음", "Not Exist Register-Device"), 
		FAIL_806(806, "단말 모델 존재 하지 않음", "단말 모델정보 없음"),
		FAIL_807(807, "비밀번호 인증 실패", "password error"), 
		FAIL_820(820, "이미 등록된 단말", "Already Registered Device"),
		FAIL_821(821, "존재하지 않는 사용자", "Not find user"), 
		FAIL_822(822, "권한이 없는 요청", "Permission Denied"),
		FAIL_830(830, "단말 연결 되지 않음", "Device Connect Failure"), 
		FAIL_831(831, "단말 응답 시간 초과", "Device Time out"),
		FAIL_832(832, "단말 응답은 성공, 제어결과 이벤트 응답시간 초과", "Device Event Time out"),
		FAIL_833(833, "단말 제어결과 싪패", "Device Control Result Fail"),
		FAIL_834(834, "단말로부터 수신한 메세지 형식 에러", "단말로부터 수신한 메시지 포멧 오류"),

		FAIL_900(900, "허용하지 않은 제휴사 정보 사용", "Invalid Vendor Info"),
		FAIL_901(901, "허용하지 않는 기능 API Key 사용", "Invalid API Key"),
		FAIL_902(902, "전문중 Header 항목 누락", "Mandatory Field of Header Omitted"),
		FAIL_903(903, "등록되지 않은 디바이스 타입 정보 사용", "Device Type Unregistered"),
		FAIL_904(904, "등록되지 않은 X-HIT-Version 정보 사용", "Version Unregisted"),
		FAIL_910(910, "제휴사 및 Gateway와 연동간 접속시 실패", "Partnership Connect Refuse"),
		FAIL_914(914, "해당 사용자 정보에 대해 제휴사 및 Gatewa에서 인증 실패함", "Invalid Partnership Account Authentication"),
		FAIL_920(920, "프로파일 검증간, Command 값이 누락", "Mandatory Field of Profile Command"),
		FAIL_921(921, "프로파일 검증간, 필수 파라미터가 누락", "Invalid Parameter"),
		FAIL_923(923, "프로파일 검증간, 필수 파라미터 값의 범위가 벗어남", "Invalid Profile Parameter Range"),
		FAIL_927(927, "프로파일 검증간, 해당 command에 정의되지 않은 속성이 존재함", "Command Undefined property exist"),
		FAIL_941(941, "기기에러", "Device Error"),

		FAIL_970(970, "해당 사용자는 관리사무소 승인을 받지 않음", "Unauthorized Users"),
		FAIL_971(971, "여러 개 동호를 갖고 있는 사용자", "Multiple Dongho Account Users"),
		FAIL_972(972, "해당 사용자 현장은 LG 서비스 사용 않음", "Not user LG Service"),
		FAIL_973(973, "해당 ID는 동호가 없음", "Account does not match Dongho"),
		FAIL_974(974, "Access token 만료", "Access Token Expiration"),
		FAIL_975(975, "Refresh token 만료", "Refresh Token Expiration"),
		FAIL_979(979, "계정관련 기타 에러", "Not Defind ID Error"),

		FAIL_999(999, "정의되지 않은 에러", "Other Error");

		private int mIdx;
		private String mContent;
		private String mEngContent;

		private CODE(int idx, final String txt, String txtEng) {
			this.setmIdx(idx);
			this.mContent = txt;
			this.setmEngContent(txtEng);
		}

		public String getContents() {
			return mContent;
		}

		public static String getContents(final CODE kind) {
			return kind.mContent;
		}

		public int getmIdx() {
			return mIdx;
		}

		public void setmIdx(int mIdx) {
			this.mIdx = mIdx;
		}

		public String getmEngContent() {
			return mEngContent;
		}

		public void setmEngContent(String mEngContent) {
			this.mEngContent = mEngContent;
		}
	}
	
	public static Map<String, Object> getErrorInfo(int code, String message){
		Map<String, Object> error = new HashMap<String, Object>();
		
		error.put("code", Integer.toString(code));
		error.put("message", message);
		
		return error;
	}

}
