package com.icontrols.kakao.common;

import java.util.HashMap;
import java.util.Map;

public class KAKAO_RESULT {
	public static final int SUCCESS 						= 200, 
							FAIL_INTERNAL 					= -200,
							FAIL_EXPIREDTOKEN 				= -201,
							FAIL_UNREACHABLE				= -202,
							FAIL_NONEXIST					= -203,
							FAIL_THING_INTERNAL				= -204,
							FAIL_INVALID_REQ				= -205,
							FAIL_INVALID_TOKEN				= -206,
							FAIL_INVALID_CLIENT				= -207,
							FAIL_UNLINKEXTENSION_SERVICE 	= -208,
							FAIL_EXTENSION_SERVICE_TOKEN 	= -209;
	
	public enum CODE {
		SUCCESS(200, "정상동작", "Success"),
		
		FAIL_INTERNAL				(-200, "InternalServerError", 		"내부 서버 에러"),
		FAIL_EXPIREDTOKEN			(-201, "ExpiredAccessToken", 		"인증토큰 만료"),
		FAIL_UNREACHABLE			(-202, "ThingUnreachable", 			"Things 연결 실패"),
		FAIL_NONEXIST				(-203, "ThingNonexistent", 			"정의되지않은 기기 Endpoint"),
		FAIL_THING_INTERNAL			(-204, "ThingInternalError", 		"기기에서 처리할 수 없는 요청" ),
		FAIL_INVALID_REQ			(-205, "InvalidRequest", 			"올바르지 않은 요청메세지"),
		FAIL_INVALID_TOKEN			(-206, "InvalidAccessToken", 		"유효하지 않은 인증토큰"),
		FAIL_INVALID_CLIENT			(-207, "InvalidClient", 			"Client 인증 실패"),
		FAIL_UNLINKEXTENSION_SERVICE(-208, "UnlinkExtensionService",	"Client 인증 실패"),
		FAIL_EXTENSION_SERVICE_TOKEN(-209, "ExtensionServiceTokenError","확장서비스 토큰 오류");
		
		private int resultCode;
		private String message;
		private String description;
		
		private CODE(int resultCode, String message, String description) {
			this.resultCode = resultCode;
			this.message = message;
			this.description = description;
		}

		public int getResultCode() {
			return resultCode;
		}

		public void setResultCode(int resultCode) {
			this.resultCode = resultCode;
		}

		public String getMessage() {
			return message;
		}

		public void setMessage(String message) {
			this.message = message;
		}

		public String getDescription() {
			return description;
		}

		public void setDescription(String description) {
			this.description = description;
		}
		
		
	}
	
	public static Map<String, Object> getErrorInfo(int code){
		Map<String, Object> error = new HashMap<String, Object>();
		
		for(KAKAO_RESULT.CODE CODE : KAKAO_RESULT.CODE.values()) {
			if(code == CODE.getResultCode()) {
				error.put(KEY_INFO.ERROR_KEY_CODE, Integer.toString(code));
				error.put(KEY_INFO.ERROR_KEY_MESSAGE, CODE.getMessage());
				
				return error;
			}
		}
		return null;
	}
}
