package com.icontrols.kakao.common.utils;

import java.io.UnsupportedEncodingException;
import java.security.GeneralSecurityException;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
import java.util.Base64.Decoder;
import java.util.HashMap;
import java.util.Map;

import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icontrols.kakao.common.KAKAO_RESULT;

import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;

public class JWTUtils2 {
	private static final Logger logger = LoggerFactory.getLogger(JWTUtils2.class);
	private static final String ACCESS_TOEKN_SECRET_KEY = "dlswmdaWNvbnRyb2xzMTc5MyFAIw==";
	private static final String REFRESH_TOKEN_SECRET_KEY = "";
	
	public JWTUtils2() {
		super();
	}

//	// icontrols1793!@# base64인코딩하고앞에 난수(dlswmd) 붙임
//	public static String ACCESS_TOEKN_SECRET_KEY = "dlswmdaWNvbnRyb2xzMTc5MyFAIw==";
//	// icontrolsrefresh1793!@#
//	public static String REFRESH_TOKEN_SECRET_KEY = "aWNvbnRyb2xzcmVmcmVzaDE3OTMhQCM=";
//	public static void main(String[] args) {
//		String token = "eyJhbGciOiJIUzI1NiJ9.eyJleHAiOjQzMjAwLCJjbXBJcCI6Ik1qSXhMakUyTXk0eU5ETXVNdz09IiwiaG9tZUlkIjoiTXZwVDN2dGgvMU5QOW5MK3phdnplQT09IiwiaWF0IjoxNjE3NjM1NDAxLCJjbGllbnRJbmZvIjoiTVBBSFhLV0VMUyJ9.hfJ1pKE1eLQBvosjCavrpGhp1f7jQNfs_OY6uCN-";
//		Map<String, Object> _map = JWTUtils2.getTokenInfo(token);
//		
//		System.out.println("-->" + _map);
//	}
	public static Map<String, Object> getTokenInfo(String token){
		String secretKey = "";
		Map<String, Object> rMap = new HashMap<String, Object>();
		
		try {
			secretKey = ACCESS_TOEKN_SECRET_KEY;
			
//			logger.info(token);
			Decoder decoder = Base64.getDecoder();
			// 시그니처가 맞는지 확인
			String enPayload = token.split("\\.")[1];
			String dePayload = new String(decoder.decode(enPayload));
			
			JSONObject obj = new JSONObject(dePayload);

			String jwt = Jwts.builder().claim("exp", obj.get("exp")) // 1시간 -> 설정정보로 변경해야함
					.claim("cmpIp", obj.get("cmpIp")).claim("homeId", obj.get("homeId")).claim("iat", obj.get("iat"))
					.claim("clientInfo", obj.get("clientInfo"))
					.signWith(SignatureAlgorithm.HS256, secretKey.getBytes("UTF-8")).compact();
			
			String encodedHomeId = obj.get("homeId").toString();
			AES256Util aes = new AES256Util();
			String homeId = aes.decrypt(encodedHomeId);
			int longTime = (int)obj.get("iat");
			System.out.println("longtime =" + longTime);
			rMap.put("cmpIp", obj.get("cmpIp"));
			rMap.put("homeId", homeId);
			rMap.put("iat", CommonUtil.getStrTypeTimeWithLongType(longTime));
			rMap.put("clientInfo", obj.get("clientInfo"));
			
		}catch(Exception e) {
			rMap.put("ERROR", e.getMessage());
			e.printStackTrace();
		}
		
		return rMap;
	}
	/**
	 * 
	 * @param token
	 * @return 
	 * @throws UnsupportedEncodingException
	 */
	public static int validateToken(String token) throws UnsupportedEncodingException {

		String secretKey = "";
		try {
			secretKey = ACCESS_TOEKN_SECRET_KEY;
			
//			logger.info(token);
			Decoder decoder = Base64.getDecoder();
			// 시그니처가 맞는지 확인
			String enPayload = token.split("\\.")[1];
			String dePayload = new String(decoder.decode(enPayload));
			
			JSONObject obj = new JSONObject(dePayload);

			String jwt = Jwts.builder().claim("exp", obj.get("exp")) // 1시간 -> 설정정보로 변경해야함
					.claim("cmpIp", obj.get("cmpIp")).claim("homeId", obj.get("homeId")).claim("iat", obj.get("iat"))
					.claim("clientInfo", obj.get("clientInfo"))
					.signWith(SignatureAlgorithm.HS256, secretKey.getBytes("UTF-8")).compact();
			
			if (token.equals(jwt)) {
				long iat = Long.parseLong(obj.get("iat").toString());
				long currentTime = System.currentTimeMillis() / 1000;
				if (currentTime > iat + Long.parseLong(obj.get("exp").toString())) {
					return KAKAO_RESULT.FAIL_EXPIREDTOKEN;
				}
				return KAKAO_RESULT.SUCCESS;
			}
		}catch(Exception e) {
			return KAKAO_RESULT.FAIL_INVALID_TOKEN;
		}
		
		return KAKAO_RESULT.FAIL_INVALID_TOKEN;

	}
//	
//	static public boolean validateToken(String token, String type) throws UnsupportedEncodingException {
//
//		String secretKey = "";
//		if (type.equals("accessToken")) {
//			secretKey = CONSTANTS.ACCESS_TOEKN_SECRET_KEY;
//		} else if (type.equals("refreshToken")) {
//			secretKey = CONSTANTS.REFRESH_TOKEN_SECRET_KEY;
//		}
//		logger.info(token);
//		Decoder decoder = Base64.getDecoder();
//		// 시그니처가 맞는지 확인
//		String enHeader = token.split("\\.")[0];
//		logger.info("H= " + enHeader);
//		String enPayload = token.split("\\.")[1];
//		String dePayload = new String(decoder.decode(enPayload));
//		logger.info("P= " + enPayload);
//		String signiture = token.split("\\.")[2];
//		logger.info("S= " + signiture);
//		JSONObject obj = new JSONObject(dePayload);
//
//		String jwt = Jwts.builder().claim("exp", obj.get("exp")) // 1시간 -> 설정정보로 변경해야함
//				.claim("cmpIp", obj.get("cmpIp"))
//				.claim("homeId", obj.get("homeId"))
//				.claim("iat", obj.get("iat"))
//				.claim("clientInfo", obj.get("clientInfo"))
//				.signWith(SignatureAlgorithm.HS256, secretKey.getBytes("UTF-8")).compact();
//		logger.info("new = " + jwt);
//
//		if (!type.equals("refreshToken") && token.equals(jwt)) { // 갱신인 경우에는 시간 검사를 안하기 위해
//			long iat = Long.parseLong(obj.get("iat").toString());
//			long currentTime = System.currentTimeMillis() / 1000;
//			if (currentTime > iat + Long.parseLong(obj.get("exp").toString())) {
//				return false;
//			}
//			return true;
//		}
//		return false;
//
//	}
	/**
	 * 
	 * @param token
	 * @return 동/호
	 * @throws UnsupportedEncodingException
	 * @throws NoSuchAlgorithmException
	 * @throws GeneralSecurityException
	 */

	public static String getHomeIdFromToken(String token)
			throws UnsupportedEncodingException, NoSuchAlgorithmException, GeneralSecurityException {

		Decoder decoder = Base64.getDecoder();
		String enPayload = token.split("\\.")[1];
		String dePayload = new String(decoder.decode(enPayload));
		JSONObject obj = new JSONObject(dePayload);

		String encodedHomeId = obj.get("homeId").toString();
		AES256Util aes = new AES256Util();
		String homeId = aes.decrypt(encodedHomeId);

		return homeId;
	}

}
