package com.icontrols.kakao.common.utils;

import java.io.UnsupportedEncodingException;
import java.security.GeneralSecurityException;
import java.security.NoSuchAlgorithmException;
import java.util.UUID;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icontrols.kakao.controller.MainController;


public class UtilLib {
	private static final Logger logger = LoggerFactory.getLogger(MainController.class);

	// 인코딩하고 뒤에 난수 붙여서 리턴
	public static String generateDeviceID(String modelId, int dong, int ho, int roomNum, int cirNum)
			throws UnsupportedEncodingException, NoSuchAlgorithmException, GeneralSecurityException {

		String result = null;

		String deviceID = dong + "_" + ho + "_" + modelId + "_" + roomNum + "_" + cirNum;
		AES256Util aes = new AES256Util();
		String enc = aes.encrypt(deviceID);
//		logger.info(enc);
		String random = UUID.randomUUID().toString().substring(0, 3);
		result = random + enc;

		return result;
	}

	// 디코딩 진행
	public static String decodeDeviceID(String deviceId)
			throws UnsupportedEncodingException, NoSuchAlgorithmException, GeneralSecurityException {
		String result = null;
		String dec = deviceId.substring(3, deviceId.length());
		AES256Util aes = new AES256Util();
		result = aes.decrypt(dec);
		// 디코딩진행
		return result;
	}

}
