package com.icontrols.kakao.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.icontrols.kakao.common.utils.CommonUtil;
import com.icontrols.kakao.service.AccessTokenService;

@RestController
public class AccessTokenController {
	
	private static final Logger logger = LoggerFactory.getLogger(AccessTokenController.class);
	
	@Autowired
	AccessTokenService accessService;
	
	@RequestMapping(value = "/kakao/accessToken", method = RequestMethod.POST, consumes = "application/json")
	public @ResponseBody Map<String, Object> reqCode(@RequestHeader HttpHeaders header,
													@RequestBody Map<String, Object> params,
													HttpServletResponse response, 
													HttpServletRequest request) throws Exception {
		Map<String, Object> retMap = new HashMap<String, Object>();
		
		String reqId = (String) params.get("id");
		String type = (String) params.get("type");
		Map<String, Object> body = (HashMap<String, Object>) params.get("body");
		
		logger.info("[accessToken]-[" + reqId + "]- id [" + params.get("id") + "] - type [" + type + "] - body [" + body.toString() + "]");
		
		switch(type) {
		case "CREATE":
			retMap.putAll(accessService.create(body));
			break;
		case "REFRESH":
			retMap.putAll(accessService.refresh(body));
			break;
		case "GET":
			retMap.putAll(accessService.get(body));
			break;
		}
		String result = retMap.containsKey("error")?"ERROR":"SUCCESS";
		
		retMap.put("result", result);
		
		retMap.put("id", reqId);
		retMap.put("type", type);
		logger.info("[accessToken]-[" + reqId + "]-  RESULT - " + retMap.toString());
		return retMap;
	}
}
