package com.icontrols.kakao.controller;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.icontrols.kakao.entity.ThingsInfo;
import com.icontrols.kakao.repo.ThingsInfoRepository;
import com.icontrols.kakao.service.AuthService;


@RestController
public class AuthController {
	private static final Logger logger = LoggerFactory.getLogger(AuthController.class);

	@Autowired
	AuthService authService;
	
	@Autowired
	ThingsInfoRepository thingsRepo;
	
	@RequestMapping(value = "/kakao/auth", method = RequestMethod.POST, consumes = "application/json")
	public @ResponseBody Map<String, Object> reqCode(@RequestBody Map<String, Object> body) throws Exception {
		logger.info("[AUTH] - "+body.toString());
		Map<String, Object> retMap = authService.authProcess(body);
		
		return retMap;
	}
	
	@RequestMapping(value = "/kakao/test", method = RequestMethod.POST, consumes = "application/json")
	public @ResponseBody Map<String, Object> test(@RequestBody Map<String, Object> body) throws Exception {
		
		ThingsInfo[] list = {
				new ThingsInfo("temper_5", "temper" , "802", "2504"),
		 new ThingsInfo("light02_4", "light02" , "802", "2504"),
		 new ThingsInfo("light03_3", "light03" , "802", "2504"),
		 new ThingsInfo("temper_4", "temper" , "802", "2504"),    
		 new ThingsInfo("light01_4", "light01" , "802", "2504"),        
		 new ThingsInfo("light02_3", "light02" , "802", "2504"),        
		 new ThingsInfo("light03_2", "light03" , "802", "2504"),        
		 new ThingsInfo("temper_3", "temper" , "802", "2504"),        
		 new ThingsInfo("ventil_1", "ventil" , "802", "2504"),   
		 new ThingsInfo("temper_2", "temper" , "802", "2504"),   
		 new ThingsInfo("temper_1", "temper" , "802", "2504"),   
		 new ThingsInfo("light01_1", "light01" , "802", "2504"),   
		 new ThingsInfo("light01_3", "light01" , "802", "2504"),   
		 new ThingsInfo("light02_2", "light02" , "802", "2504"),   
		 new ThingsInfo("light03_1", "light03" , "802", "2504"),   
		 new ThingsInfo("colorDimming_livinglight_5", "livinglight" , "802", "2504"),       
		 new ThingsInfo("light01_2", "light01" , "802", "2504"),       
		 new ThingsInfo("light02_1", "light02" , "802", "2504"),       
		 new ThingsInfo("gas_1", "gas" , "802", "2504"),      
		 new ThingsInfo("colorDimming_livinglight_1", "livinglight" , "802", "2504"),       
		 new ThingsInfo("colorDimming_livinglight_2", "livinglight" , "802", "2504"),       
		 new ThingsInfo("colorDimming_livinglight_3", "livinglight" , "802", "2504"),       
		 new ThingsInfo("colorDimming_livinglight_4", "livinglight" , "802", "2504"),
		 new ThingsInfo("ElevatorCaller", "elevator" , "802", "2504"),
		 new ThingsInfo("electric01", "electric" , "802", "2504"),       
		 new ThingsInfo("electric02", "electric" , "802", "2504"),       
		 new ThingsInfo("electric03", "electric" , "802", "2504"),       
		 new ThingsInfo("electric04", "electric" , "802", "2504"),
		 new ThingsInfo("electric05", "electric" , "802", "2504")
		 };
		
		
		for(ThingsInfo info:list) {
			thingsRepo.save(info);
		}
		
		
//		logger.info("kakao test --<>>>>> --> " + thingsRepo.count());
		Map<String, Object> retMap = new HashMap<String, Object>();
		
		
		retMap.put("UUID", UUID.randomUUID().toString());
		
		
		return retMap;
	}
}
