package com.icontrols.kakao.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.ColumnDefault;

@Entity
@Table(name = "tbl_user_info")
public class UserInfo implements Serializable{

	private static final long serialVersionUID = 4832595590796050945L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private long id;
	
	@Column(name = "access_token")
	private String accessToken;
	
	@Column(name = "refresh_token")
	private String refreshToken;
	
	@Column(name = "kakao_access_token")
	private String kakaoAccessToken;
	
	@Column(name = "kakao_refresh_token")
	private String kakaoRefreshToken;
	
	@Column(name = "kakao_expires_time")
	private String kakaoExpiresTime;

	@Column(name = "kakao_token_create_time")
	private String kakaoTokenCreateTime;
	
	@Column(name = "kakao_token_expire_time")
	private String kakaoTokenExpireTime;
	
	@Column(name = "delete_flag")
	private String deleteFlag;
	
	@Column(name = "delete_type")
	private String deleteType;
	
	@Column(name = "prev_user_id")
	@ColumnDefault("0")
	private long prevUserId;
	
	@ManyToOne
	@JoinColumn(name = "dongho_id")
	private DonghoInfo donghoInfo;
	public UserInfo() {
		super();
		// TODO Auto-generated constructor stub
	}
	public UserInfo(String accessToken, String refreshToken, DonghoInfo donghoInfo) {
		super();
		this.accessToken = accessToken;
		this.refreshToken = refreshToken;
		this.donghoInfo = donghoInfo;
		this.deleteFlag = "N";
		this.deleteType = "";
	}
	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	public String getAccessToken() {
		return accessToken;
	}
	public void setAccessToken(String accessToken) {
		this.accessToken = accessToken;
	}
	public String getRefreshToken() {
		return refreshToken;
	}
	public void setRefreshToken(String refreshToken) {
		this.refreshToken = refreshToken;
	}
	public String getKakaoAccessToken() {
		return kakaoAccessToken;
	}
	public void setKakaoAccessToken(String kakaoAccessToken) {
		this.kakaoAccessToken = kakaoAccessToken;
	}
	public String getKakaoRefreshToken() {
		return kakaoRefreshToken;
	}
	public void setKakaoRefreshToken(String kakaoRefreshToken) {
		this.kakaoRefreshToken = kakaoRefreshToken;
	}
	public String getKakaoExpiresTime() {
		return kakaoExpiresTime;
	}
	public void setKakaoExpiresTime(String kakaoExpiresTime) {
		this.kakaoExpiresTime = kakaoExpiresTime;
	}
	public String getKakaoTokenCreateTime() {
		return kakaoTokenCreateTime;
	}
	public void setKakaoTokenCreateTime(String kakaoTokenCreateTime) {
		this.kakaoTokenCreateTime = kakaoTokenCreateTime;
	}
	public String getKakaoTokenExpireTime() {
		return kakaoTokenExpireTime;
	}
	public void setKakaoTokenExpireTime(String kakaoTokenExpireTime) {
		this.kakaoTokenExpireTime = kakaoTokenExpireTime;
	}
	public String getDeleteFlag() {
		return deleteFlag;
	}
	public void setDeleteFlag(String deleteFlag) {
		this.deleteFlag = deleteFlag;
	}
	public String getDeleteType() {
		return deleteType;
	}
	public void setDeleteType(String deleteType) {
		this.deleteType = deleteType;
	}
	
	public long getPrevUserId() {
		return prevUserId;
	}
	public void setPrevUserId(long prevUserId) {
		this.prevUserId = prevUserId;
	}
	public DonghoInfo getDonghoInfo() {
		return donghoInfo;
	}
	public void setDonghoInfo(DonghoInfo donghoInfo) {
		this.donghoInfo = donghoInfo;
	}
	
	
	@Override
	public String toString() {
		return "UserInfo [id=" + id + ", accessToken=" + accessToken + ", refreshToken=" + refreshToken
				+ ", kakaoAccessToken=" + kakaoAccessToken + ", kakaoRefreshToken=" + kakaoRefreshToken
				+ ", kakaoExpiresTime=" + kakaoExpiresTime + ", kakaoTokenCreateTime=" + kakaoTokenCreateTime
				+ ", kakaoTokenExpireTime=" + kakaoTokenExpireTime + ", deleteFlag=" + deleteFlag + ", deleteType="
				+ deleteType + ", donghoInfo=" + donghoInfo + "]";
	}
}
