package com.icontrols.kakao.socket.utils;

public class XMLConstants {
	public enum REMOTE_KIND {
		// 기존 iCMD 프로토콜
		remote_get_home_devices(0, "remote_get_home_devices"),
		remote_access_livinglight(1, "remote_access_livinglight"), remote_access_gas(2, "remote_access_gas"),
		remote_access_doorlock(3, "remote_access_doorlock"), remote_access_temper(4, "remote_access_temper"),
		remote_access_mode(5, "remote_access_mode"), remote_access_ventil(6, "remote_access_ventil"),
		remote_access_curtain(7, "remote_access_curtain"), remote_access_sysaircon(8, "remote_access_sysaircon"),
		remote_access_light(9, "remote_access_light"), remote_access_electric(10, "remote_access_electric"),
		remote_access_light_batch_control(11, "remote_access_light_batch_control"),

		// 신규 추가 iCMD 프로토콜
		msg_elevator_call(12, "msg_elevator_call"), msg_notice_list(13, "msg_notice_list"),
		msg_device_subscription(14, "msg_device_subscription"),
		msg_device_unsubscription(15, "msg_device_unsubscription"),
		renew_remote_get_home_devices(16, "renew_remote_get_home_devices"),
		msg_home_device_set_control(17, "msg_home_device_set_control"),
		msg_home_device_get_status(18, "msg_home_device_get_status"), msg_visitor_list(19, "msg_visitor_list"),
		msg_car_parking_list(20, "msg_car_parking_list"),
		remote_register_new_device_auth_number(21, "remote_register_new_device_auth_number"),
		msg_total_devices_status(22, "msg_total_devices_status"),
		msg_aircon_attributes(23, "msg_aircon_attributes");
		
		private int mIdx;
		private String mTextXmlData;

		private REMOTE_KIND(int idx, final String xmlContents) {
			this.setmIdx(idx);
			this.mTextXmlData = xmlContents;
		}

		public String getContents() {
			return mTextXmlData;
		}

		public int getmIdx() {
			return mIdx;
		}

		public void setmIdx(int mIdx) {
			this.mIdx = mIdx;
		}

	}

	public enum ACTION_XML {
		STATUS(0, "status"), CONTROL(1, "control");

		private int idx;
		private String content;

		private ACTION_XML(final int idx, final String content) {
			this.setIdx(idx);
			this.content = content;
		}

		public String getConents() {
			return this.content;
		}

		public int getIdx() {
			return idx;
		}

		public void setIdx(int idx) {
			this.idx = idx;
		}

	}

	public enum COM_MSG {
		SUCCESS(1, "success"), // 정상 요청 응답
		TIMEOUT(98, "timeout"), INVALID_INDEX(97, "invalid index"), INVALID_ITEMSEQ(96, "invalid itemseq"),
		NO_SEARCH_DATA(95, "no search data"), ERROR(99, "error");

		private int idx;
		private String content;

		private COM_MSG(final int idx, final String content) {
			this.setIdx(idx);
			this.content = content;
		}

		public String getConents() {
			return this.content;
		}

		public int getIdx() {
			return idx;
		}

		public void setIdx(int idx) {
			this.idx = idx;
		}

	}

	public static int msg_num = 1;

	public static String getImapMsgNum() {
		msg_num++;
		if (msg_num > 255)
			msg_num = 1;
		return String.valueOf(msg_num);
	}
}
