package com.icontrols.kakao.socket.wallpad;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import javax.net.ServerSocketFactory;
import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icontrols.kakao.common.SERVERINFO;
import com.icontrols.kakao.common.utils.CommonUtil;

public class ImapMultiSocketSSLServer extends Thread{
	private static final Logger logger = LoggerFactory.getLogger(ImapMultiSocketSSLServer.class);
	ServerSocket svr;
	
	private SSLServerSocket sslSvr;
	boolean receiveSocketRun = true;
	
	private int serverPort;
	
	public ImapMultiSocketSSLServer(){
		try {
			serverPort = SERVERINFO.WalladReceivePort;
			ServerSocketFactory ssf = SSLServerSocketFactory.getDefault();
			ServerSocket sck = ssf.createServerSocket(serverPort);
			logger.info("**********************************************************");
			logger.info("SSL Event Server Socket Start!");
			logger.info("...");
			logger.info("이벤트 수신 IP" + sck.getLocalSocketAddress());
			logger.info("...");
			logger.info("이벤트 수신 포트 : " + sck.getLocalPort());
			logger.info("...");
			logger.info("Timeout : " + sck.getSoTimeout());
			logger.info("**********************************************************");
			
			while(true) {
				logger.info("Waiting New Event Message ... " );
				
				Socket connectedCLientSocket = sck.accept();
				
				logger.info("Connect Client IP : " + connectedCLientSocket.getInetAddress() + " || Client Port : " + connectedCLientSocket.getLocalPort());
				
				new ThreadServerHandler(connectedCLientSocket, CommonUtil.getUpdateNoticeNewDanjiServer()).start();
			}
		}catch(Exception e) {
			logger.error("SSL server Socket 생성 실패" );
			logger.error(e.getMessage());
			e.printStackTrace();
		}
	}
	
	public void run() {
		while(receiveSocketRun) {
			try {
				Socket socket = sslSvr.accept();
			}catch(Exception e) {
				logger.error("SSL Server Socket Start Error");
				logger.error(e.getMessage());
				e.printStackTrace();
			}
		}
	}
}
