package com.icontrols.kakao.socket.wallpad;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icontrols.kakao.common.utils.BeanUtils;
import com.icontrols.kakao.entity.DonghoInfo;
import com.icontrols.kakao.entity.UserInfo;
import com.icontrols.kakao.repo.DonghoInfoRepository;
import com.icontrols.kakao.service.AuthService;

public class UnlinkExtensionHandler extends Thread{
	private static final Logger logger = LoggerFactory.getLogger(UnlinkExtensionHandler.class);
	private String dong;
	private String ho;
	
	Map<String, Object> subsMap = null;
	
	AuthService authService;
	
	public UnlinkExtensionHandler(String dong, String ho) {
		this.dong = dong;
		this.ho = ho;
		
		this.subsMap = new HashMap<String, Object>();
		this.subsMap.put("type", "unsubs");
		this.subsMap.put("dong", dong);
		this.subsMap.put("ho", ho);
		this.subsMap.put("devNum", "1");
		this.subsMap.put("company", "kakao");
		
	}
	
	public void run() {
		Map<String, Object> retMap = null;
		try {
			logger.info("[UnlinkExtensionHandler] - [START]");
			DonghoInfoRepository dRepo = (DonghoInfoRepository)BeanUtils.getBean("donghoInfoRepository");
			List<DonghoInfo> dList = dRepo.findByDongAndHo(this.dong, this.ho);
			
			// 해당 동호가 검색되지 않으면 프로세스 종료..
			if(dList.size() == 0) return;
			
			DonghoInfo dInfo = dList.get(0);
			
			List<UserInfo> uList = dInfo.getUserInfos();
			
			int linkedUserCnt = 0;
			for(UserInfo userInfo:uList) {
				if(userInfo.getDeleteFlag().equalsIgnoreCase("N")) linkedUserCnt++;
			}

			// 아직 해지하지 않은 사용자가 있으면 구독 해지를 날리면 안된다.
			if(linkedUserCnt > 0) return;
			
			
			// 해당 동호수에 인원이 없을 경우 월패드 구독 해지를 진행해야 한다.
			authService = (AuthService)BeanUtils.getBean("authServiceImpl");
			retMap = authService.subscriptionProcess(subsMap);
			
			
			logger.info("[UnlinkExtensionHandler] - [END] - [dong:"+this.dong+"]-[ho:"+this.ho+"]-[RESULT:" + retMap.toString()+"]");
		}catch(Exception e) {
			logger.error("[UnlinkExtensionHandler] - [ERROR] - " + e.getMessage());
			e.printStackTrace();
		}finally {
		}
	}
}
